package edu.rice.comp322;

import edu.rice.hj.api.SuspendableException;

import java.io.IOException;

/**
 * @author <a href="http://shams.web.rice.edu/">Shams Imam</a> (shams@rice.edu)
 */
public class ParallelLexicalBenchmark extends Benchmark {

    public static void main(final String[] args) {
        BenchmarkRunner.runBenchmark(args, new ParallelLexicalBenchmark());
    }

    protected ProblemState solution;

    protected ParallelLexicalBenchmark() {
        super();
    }

    @Override
    public void initialize(final String[] args) throws IOException {
        SudokuConfig.parseArgs(args);
        solution = null;
    }

    @Override
    public void printArgInfo() {
        SudokuConfig.printArgs();
    }

    @Override
    public void runIteration() throws SuspendableException {
        computeSudoku();
    }

    @Override
    public void cleanupIteration(final boolean lastIteration, final double execTimeMillis) {

        SudokuConfig.validate(this, solution);

        if (!lastIteration) {
            solution = null;
        }
        System.out.println();
    }

    @Override
    protected ProblemState computeSudoku() throws SuspendableException {

        // TODO introduce eureka, might require changing signature of computeSudoku() also.
        solution = new SequentialBenchmark().computeSudoku();

        if (solution != null) {
            System.out.printf(BenchmarkRunner.argOutputFormat, "Num Moves to Solution", solution.numMoves);
        }

        return solution;
    }

}
